/* tslint:disable */
import { Injectable } from '@angular/core';
import { HttpClient, HttpRequest, HttpResponse, HttpHeaders } from '@angular/common/http';
import { BaseService as __BaseService } from '../base-service';
import { CrmConfiguration as __Configuration } from '../crm-configuration';
import { StrictHttpResponse as __StrictHttpResponse } from '../strict-http-response';
import { Observable as __Observable } from 'rxjs';
import { map as __map, filter as __filter } from 'rxjs/operators';

import { ResponseArgsOfIEnumerableOfAddressDTO } from '../models/response-args-of-ienumerable-of-address-dto';
import { AddressDTO } from '../models/address-dto';
@Injectable({
  providedIn: 'root',
})
class AddressService extends __BaseService {
  static readonly AddressValidateAddressPath = '/customer/address/validate';

  constructor(
    config: __Configuration,
    http: HttpClient
  ) {
    super(config, http);
  }

  /**
   * Validiert die angegebenen Adressdaten auf ihre Gültigkeit und liefert (soweit möglich) Vorschläge zur Korrektur
   * Result = null: Adresse ist gültig
   * Result = empty Array: Adresse ist ungültig, keine Adressvorschläge
   * Result = AdressDTO[x]: Adresse ist ungültig, x Adressvorschläge
   * @param address AdressDTO mit city, zipCode, street, streetNumber, country
   */
  AddressValidateAddressResponse(address: AddressDTO): __Observable<__StrictHttpResponse<ResponseArgsOfIEnumerableOfAddressDTO>> {
    let __params = this.newParams();
    let __headers = new HttpHeaders();
    let __body: any = null;
    __body = address;
    let req = new HttpRequest<any>(
      'POST',
      this.rootUrl + `/customer/address/validate`,
      __body,
      {
        headers: __headers,
        params: __params,
        responseType: 'json'
      });

    return this.http.request<any>(req).pipe(
      __filter(_r => _r instanceof HttpResponse),
      __map((_r) => {
        return _r as __StrictHttpResponse<ResponseArgsOfIEnumerableOfAddressDTO>;
      })
    );
  }
  /**
   * Validiert die angegebenen Adressdaten auf ihre Gültigkeit und liefert (soweit möglich) Vorschläge zur Korrektur
   * Result = null: Adresse ist gültig
   * Result = empty Array: Adresse ist ungültig, keine Adressvorschläge
   * Result = AdressDTO[x]: Adresse ist ungültig, x Adressvorschläge
   * @param address AdressDTO mit city, zipCode, street, streetNumber, country
   */
  AddressValidateAddress(address: AddressDTO): __Observable<ResponseArgsOfIEnumerableOfAddressDTO> {
    return this.AddressValidateAddressResponse(address).pipe(
      __map(_r => _r.body as ResponseArgsOfIEnumerableOfAddressDTO)
    );
  }
}

module AddressService {
}

export { AddressService }
